A while ago I made a tiny function in my ~/.zshrc to download a video from the link in my clipboard. I use this nearly every day to share videos with people without forcing them to watch it on whatever site I found it. What’s a script/alias that you use a lot?
# Download clipboard to tmp with yt-dlp
tmpv() {
cd /tmp/ && yt-dlp "$(wl-paste)"
}
alias cls=clearMy first language was QB, so it makes me chuckle.
Also,
alias cim=vim. If I had a penny…I also have cls aliased to clear! I used to use windows terminal and found myself compulsively typing cls when I moved to linux.
For docker: I’m not following best practices. I have a giant docker compose file for my entire home lab, this is how I update things:
alias dockpull="docker compose pull" alias dockup="docker compose up -d --remove-orphans"For me it’s pretty basic. It’s mostly aliases for nix related commands, like rebuild-switch, updating, garbage collecting, because those nix commands are pretty lenghty, especially with having to point to your flake and everything. I’m thinking of maybe adding an alias for cyanrip (cli cd ripper), because i recently ripped my entire cd collection, but going forward if i buy another cd every now and then, i’ll probably end up forgetting about which flags i used.
I usually set up an alias or script to update everything on my system. For example, on Ubuntu, I would do this:
alias sysup='snap refresh && apt update && apt upgrade'And on Arch, I do this:
alias sysup ='flatpak update && paru'Funny enough you’d need to use
sudoto run this on Ubuntu, but not in the Arch example because paru being neatHere is mine for EndeavourOS (based on Arch, BTW):
alias update='eos-update --yay' alias updates='eos-update --yay ; flatpak update ; flatpak uninstall --unused ; rustup self update ; rustup update'And related for uninstalling something:
alias uninstall='yay -Rs'Can I introduce you to Topgrade? ;)
I use Topgrade, but I use the alias
updateto run it lolWhy install another bit of software when a simple alias will do the job nicely?
Because:
- If you install any new software that needs updating, you don’t need to update your alias.
- If any software makes changes that break your alias, (theoretically) the bit of software should be able to fix it quickly, without you needing to pay any attention to it.
- The bit of software can more easily do advanced things than the simple alias. For example, I added functionality to update JetBrains Toolbox and IDE’s installed with it. A simple alias could not do this, because Toolbox does not have a simple update command, however I made it work by enabling automatic updates temporarily, and then inspecting the log for updates. Now the end-user doesn’t have to think about this at all. Other things that could be done but are not implemented yet include parallelization, and listing updated components in a neat summary (PR linked).
Of course if you’re a minimalist, then you probably don’t have that much stuff that needs upgrading in the first place. For me personally I have
deb-get,uv,cargo, andflatpak, to name a few; the alias was getting longer and longer until I was able to remove it completely by switching to Topgrade.For me, I find it handy because it catches a bunch of stuff I always forget, like updating Docker containers. Also if you have Am installed it’ll even update your Appimages.
I consider updating my docker containers part of updating my dev environment, which is on a different schedule to my system updates. I use a function for updating them.
I have a similar update function here. With a bit more bells and whistles: https://github.com/dannyfritz/dotfiles/blob/e53d410364bf6e2f4e1de4b9c6abbbc832db67b1/fish/config.fish#L123
$ which diffuc diffuc: aliased to diff -uw --color=always$ which grepnir grepnir: aliased to grep -niIr$ cat `which ts` #!/bin/bash if [ "$#" -lt 1 ]; then tmux list-sessions exit fi if ! tmux attach -t "$1" then tmux new-session -s "$1" fialias nmtui="NEWT_COLORS='root=black,black;window=black,black;border=white,black;listbox=white,black;label=blue,black;checkbox=red,black;title=green,black;button=white,red;actsellistbox=white,red;actlistbox=white,gray;compactbutton=white,gray;actcheckbox=white,blue;entry=lightgray,black;textbox=blue,black' nmtui"It’s
nmtuibut pretty!Since 720p downloading isn’t really available on yt-dlp anymore, I made an alias for it
alias yt720p="yt-dlp -S vcodec:h264,fps,res:720,acodec:m4a"alias ed=$EDITORExtremely convenient on a qwerty keyboard.
This should probably be a default nowadays. Does even a single person here use the real
ed?Me. Along with vi depending on my mood.
here we go:
dedup:
#!/usr/bin/awk -f !x[$0]++this removes duplicate lines, preserving line order
iter:
#!/usr/bin/bash if [[ "${@}" =~ /$ ]]; then xargs -rd '\n' -I {} "${@}"{} else xargs -rd '\n' -I {} "${@}" {} fiThis executes a command for each line. It can also be used to compare two directories, ie:
du -sh * > sizes; ls | iter du -sh ../kittens/ > sizes2fadeout:
#!/bin/bash # I use this to fade out layered brown noise that I play at a volume of 130% # This takes about 2 minutes to run, and the volume is at zero several seconds before it's done. # ################ # DBUS_SESSION_BUS_ADDRESS is needed so that playerctl can find the dbus to use MPRIS so it can control mpv export DBUS_SESSION_BUS_ADDRESS="unix:path=/run/user/1000/bus" # ################ for i in {130..0} do volume=$(echo "scale=3;$i/100" | bc) sleep 2.3 playerctl --player=mpv volume $volume donelbn:
#!/bin/bash #lbn_pid=$(cat ~/.local/state/lbn.pid) if pgrep -fl layered_brown then pkill -f layered_brown else export DBUS_SESSION_BUS_ADDRESS="unix:path=/run/user/1000/bus" mpv -ao pulse ~/layered_brown_noise.mp3 >>lbn.log 2>&1 & sleep 3 playerctl -p mpv volume 1.3 >>lbn.log 2>&1 & fiThis plays “layered brown noise” by crysknife. It’s a great sleep aid.
here are some aliases:
alias m='mpc random off; mpc clear' alias mpcc='ncmpcpp' alias thesaurus='dict -d moby-thesaurus' alias wtf='dict -d vera' alias tvplayer='mpv -fs --geometry=768x1366+1366+0'I wrote a script called
please. You inputpleasefollowed by any other command (e.g.please git clone,please wget blahblah) and a robotic voice will say “affirmative,” then the command will run, and when it completes, the robotic voice reads out the exit code (e.g. “completed successfully” or “failed with status 1” etc.)This is useful for when you have a command that takes a long time and you want to be alerted when it’s finished. And it’s a gentleman.
I once experimented with something similar, except it was supported to trigger my smart speaker and drop into another part of the house to tell me.
Honestly, I really need to replace my proprietary smart speaker system with something self-hosted; it’s just I only recently have had the time to start cinsidering.
pleaseshare the script?It’s full of random shit I put in as a joke, but here it is. You can use
please -sto get lightly roasted when your command fails.spoiler
#!/bin/bash # announces success or failure of task if ! command -v "spd-say" > /dev/null then echo "spd-say must be installed." exit -1 fi VOLUME=0 SERIOUS=1 FINISH_ONLY=0 if [ $# -ge 2 ] then if [ $1 == "-i" ] then # parse volume from command line VOLUME=$2 shift 2 fi fi spd-say -C # force stop speech synthesizer killall -q speech-dispatcher # androgynous voice # __sayfn="spd-say -i -80 -t female3" # deep voice __sayfn="spd-say -i $VOLUME -r -10 -p -100 -t male3" function _sayfn { $__sayfn "$@" 2>/dev/null if [ $? -ne 0 ] then $__sayfn "$@" fi } if [ $# -eq 0 ] || [ "$1" == "--help" ] then _sayfn "Directive required." echo "Usage: please [-i volume] [-s|--serious] [-f|--finish] <command...>" echo " please [-i volume] --say text" echo " -i: volume in range -100 to +100" echo " --serious, -s: no silliness. Serious only. (Just kidding.)" echo " --finish, -f: do not announce start" exit -2 fi # threading issue sleep 0.001 if [ $# -ge 2 ] then if [ $1 == "--say" ] then # _sayfn the given line shift 1 _sayfn "$@" exit 0 fi if [ $1 == "--serious" ] || [ $1 == "-s" ] then shift 1 SERIOUS=0 fi if [ $1 == "--finish" ] || [ $1 == "-f" ] then shift 1 FINISH_ONLY=1 fi fi i=$(shuf -n1 -e "." "!") # inflection on voice if [ "$FINISH_ONLY" -eq 0 ] then if [ "$SERIOUS" -eq 0 ] then # startup lines (randomized for character) _sayfn -r -5 -x ".<break time=\"60ms\"/>$(shuf -n1 -e \ 'Proceeding As Directed...' \ 'By your command...' \ 'By your command...' \ 'By the power ov greyskaall!' \ 'By your command,line...' \ 'As you wish...' \ 'Stand by.' \ 'Engaged...' \ 'Initializing...' \ 'Activating' \ 'At once!' \ "Post Haste$i" \ 'it shall be done immediately' \ 'Very well.' \ 'It shall be so.' \ "righty-o$i" \ "Affirmative$i" \ "Acknowledged$i" \ "Confirmed$i" \ )" else _sayfn -r -5 -x ".<break time=\"60ms\"/>Engaged..." fi if [ $? -ne 0 ] then _sayfn "Speech engine failure." echo "Failed to run speech engine. Cancelling task." exit -3 fi fi if ! command -v "$1" > /dev/null then # _sayfn a little faster because this exits fast. _sayfn -r +10 "Unable to comply? invalid command." >&2 echo "$1: command not found." exit -4 fi eval " $@" result=$? i=$(shuf -n1 -e "," "!" "?") # inflection on voice transition=$(shuf -n1 -e "; error" ", with error" "; status") taskname=$(shuf -n1 -e "task" "task" "command" "objective" "mission" "procedure" "routine") errtext=$(shuf -n1 -e "Task_failed" "Task_failed" "Task_resulted_in_failure" "Procedure_terminated_in_an_error" "An_error_has_occurred" "Auxilliary_system_failure" "system_failure") consolation=$(shuf -n1 -e "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "Attention required." "Attention is required!" "Perhaps It was inevitable." "It may or may not be cause for alarm." "Perhaps Machines too, are fallible." "Apologies" "Hopefully nobody else was watching" "shazbot" "maybe next time." "Nobody could have predicted this outcome." "I'm very sorry." "how unfortunate." "remember: don't panic" "oh dear" "Nothing could have been done to prevent this" "Remember: No disasters are fully preventable" "perhaps the only winning move is not to play" "Remember: Failure is our teacher, not our undertaker." "Remember: If at first you don't succeed... try again." "Remember: If at first you don't succeed... try... try again." "But your friends still love you." "Remember: the machine is not your enemy." "Command?" "Awaiting further instructions." "Remember: Logic is the beginning of wisdom... not the end of it." "Remember: When you eliminate the impossible, whatever remains, however improbable, must be the truth." "Keep at it. Victory is within reach." "Remember: The road to success and the road to failure are almost exactly the same." "Now, while this could have gone better, it could also have gone much worse." "Remember: we do this not because it is easy, but because we thought it was going to be easy." "Don't give up." "It has now been... -- zero... -- days, since the last serious failure." "Remember: instead of documenting the problem, you can fix it." "Remember: Artificial intelligence is no match for artificial stupidity." "Standing by," "Remember: with every failure, we get closer to success." "We live in a society." "sometimes failure is not an option; it's a necessity." "Keep at it." "Remember: mistakes are just the first step on the road to failure... <break time=\"250ms\"/> I mean success." "Don't leave. The drones need you... <break time=\"350ms\"/> They look up to you." "Try again, for great justice." "fantastic" "brilliant" "did you really think that would work?") if [ $SERIOUS -eq 0 ] then # perhaps some silliness. if [ $result -eq 0 ] then _sayfn --wait "$(shuf -n1 -e \ "$taskname complete. All systems nominal" \ "$taskname completed successfully." \ "$taskname resulted in success." \ "$taskname yielded a successful result." \ "$taskname concluded successfully." \ "$taskname completed as instructed." \ "Jobs done." \ )" & else if [ $result -eq 1 ] then _sayfn -x --wait "$(shuf -n1 -e \ "Alert$i Primary system failure. Attention is required." \ "Alert$i System failure$i Attention required! $consolation" \ "Alert$i $taskname resulted in failure! <break time=\"150ms\"/> $consolation" \ "Alert$i $taskname was not completed as intended; $consolation" \ "Alert$i An error has occurred! <break time=\"220ms\"/> $consolation" \ )" & else _sayfn --wait -x "Alert$i $errtext$transition code $result! <break time=\"350ms\"/> $consolation" & fi fi else # no silliness here. if [ $result -eq 0 ] then _sayfn --wait "Command complete." else if [ $result -eq 1 ] then _sayfn -x --wait "Alert. Command failed; error code $result!" fi fi fi exit $resultThat’s so neat
You can also use something like notifyd to generate a pop up for visual feedback :) I can’t remember the exact command right now though. Differs per distro or desktop environment, obviously.
notify-send 'command finished!'works pretty wellAlso,
printf '\a'will output an alert bell character which should make the terminal beep/blink and be highlighted for attention by your wm/compositor if it’s unfocused.I have that aliased to
ato get notified whenever a long running command finishes just by adding;aat the end.
deleted by creator
Here is on that I actually don’t use, but want to use it in scripts. It is meant to be used by piping it. It’s simple branch with user interaction. I don’t even know if there is a standard program doing exactly that already.
# usage: yesno [prompt] # example: # yesno && echo yes # yesno Continue? && echo yes || echo no yesno() { local prompt local answer if [[ "${#}" -gt 0 ]]; then prompt="${*} " fi read -rp "${prompt}[y/n]: " answer case "${answer}" in [Yy0]*) return 0 ;; [Nn1]*) return 1 ;; *) return 2 ;; esac }I use Clevis to auto-unlock my encrypted root partition with my TPM; this means when my boot partition is updated (E.G a kernel update), I have to update the PCR register values in my TPM. I do it with my little script
/usr/bin/update_pcr:#!/bin/bash clevis luks regen -d /dev/nvme1n1p3 -s 1 tpm2I run it with sudo and this handles it for me. The only issue is I can’t regenerate the binding immediately after the update; I have to reboot, manually enter my password to decrypt the drive, and then do it.
Now, if I were really fancy and could get it to correctly update the TPM binding immediately after the update, I would have something like an apt package shim with a hook that does it seamlessly. Honestly, I’m surprised that distributions haven’t developed robust support for this; the technology is clearly available (I’m using it), but no one seems to have made a user-friendly way for the common user to have TPM encryption in the installer.
Is clevis using an attestation server or is it all on a single machine? I’m interested in getting this set up but the noted lack of batteries included for this in the common distros makes it a somewhat tall order.
In my case, no; it’s all a single machine - it is in the initramfs and uses the system’s TPM to (relatively) securely store the keys.
It can be set up with an attestation server, but you certainly don’t have to do it. The Arch wiki has a really good article on getting it set up.
How difficult is it for an adversary to get in the middle of the TPM releasing the keys to LUKS? That’s why I would want attestation of some sort, but that makes it more complicated and thinking about how that would work in practice makes my head spin…
Vulnerabilities certainly do exist, but I’m pretty sure the attacker has to be well-equipped
I’d call it a protection against data getting cracked in a petty theft, but if your attack vector is much more than that, there are other measures you should probably take. I think Clevis also works with Yubikeys and similar, meaning the system won’t decrypt without it plugged in.
Heck, I think I know someone who just keeps their boot partition with the keys on it on a flash drive and hide it on their person.
alias fuck='sudo $(history -p \!\!)'sudo !!Try it, and you will find it just does not provide the same emotional peace.
I like to imagine I’m yelling it. SUDO!!!
:D
Why not use thefuck which also corrects typos?
Because i’m not a psychopath, just autistic.
I have the same but it’s called “please”
i touch computers since almost 40 years. “Please” stopped being an option somewhere in the early 2000’s.
Nice
i use
alias kimg='kitty +kitten icat'to display images in my terminal pretty simple but nice
I have that one too, but my alias is called icat










